'use strict';

const deepFreeze = require('deep-freeze-strict');
const AppErr = require('punch-error');
const ERROR = require('../constants').ERROR;
const Nightmare = require('nightmare');

const ScrapedResult = require('../../scraped-result');

function evaluate(nightmare, link, code, options, done) {
  try {
    eval(code);
  }
  catch (err) {
    done(err);
  }
}


module.exports.scrape = function (link, config) {
  let nightmareOptions = {
    show: true,
    switches: {
      //'proxy-server': config.proxy.getIP(),
      'ignore-certificate-errors': true,
      'User-Agent': 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.8; rv:24.0) Gecko/20100101 Firefox/24.0',
      'images': false,
      'loadTimeout': 18000,
      'waitTimeout': 18000,
      'gotoTimeout': 18000
    }
  };

  return new Promise((resolve, reject) => {
    let nightmare = new Nightmare(nightmareOptions);

    let options = config.strategy.options;

    evaluate(nightmare, link, config.strategy.eval, options, function (err, result) {
      if (err) {
        console.log(err);
        return reject(new AppErr(ERROR.NIGHTMARE_ERROR));
      }
      resolve(new ScrapedResult(result));
    });
  });
};